config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'

  resources :tasks
  authenticated :user do
    root to: "dashboard#index", as: :authenticated_root
  end

  unauthenticated :user do
    root to: "dashboard#welcome"
  end

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :user

  validates :title, :description, presence: true
  validates :end_time, presence: true

  enum status: [:created, :development, :test, :accept, :refused, :finished]

  default_scope -> { where(deleted_at: nil) }

  before_validation :set_status, on: :create

  def soft_delete
    self.update(deleted_at: Time.current)
  end


  private

  def self.find_all_valid
    Task.where("end_time > ?", Time.now-3.hours)
  end

  def set_status
    self.status = :created
  end

end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable


  has_one_attached :avatar

  has_many :tasks

  validates :name, :nickname, presence: true
  enum user_type: [:admin, :ordinary]

  before_validation :set_user, on: :create

  private

  def set_user
    self.user_type = :admin if User.all.count == 0
    self.user_type = :ordinary if User.all.count > 0
  end


end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :configure_permitted_parameters, if: :devise_controller?
    rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized
    include Pundit

    private

    def user_not_authorized
        redirect_to main_app.root_path, status: :unauthorized
    end

    def configure_permitted_parameters
        devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :nickname, :avatar])
        devise_parameter_sanitizer.permit(:account_update, keys: [:name, :nickname, :avatar])
    end


end

app/controllers/dashboard_controller.rb
class DashboardController < ApplicationController
  before_action :authenticate_user!, only: [:index]
  before_action :set_tasks, only: [:index]
  
  def index
  end

  def welcome
  end

  private
  
  def set_tasks
    @tasks = current_user.tasks.find_all_valid.where(status: :created, status: :development).order("end_time ASC")
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
    before_action :authenticate_user!
    before_action :authorize_user
    before_action :set_task, only: [:show, :edit, :update, :destroy]

    
    def index
        @task = Task.new
        @tasks = current_user.tasks.find_all_valid.order("end_time ASC")
    end

    def show
    end

    def edit
    end

    def create
        @task = Task.new(task_params.merge(user: current_user))
        if @task.save
            redirect_to @task, notice: 'Task was successfully created'
        else
            render :index, notice: 'You are not able to do it'
        end
    end

    def update
        if @task.update(task_params)
            redirect_to @task, notice: 'Task was successfully updated'
        else
            render :edit, notice: 'You are not able to do it'
        end
    end

    def destroy
        if @task.soft_delete
            redirect_to tasks_url, notice: 'Task was successfully destroyed'
        else
            redirect_to @task, notice: 'You are not able to do it'
        end
    end

    private

    def set_task
        @task = Task.find(params[:id])
    end

    def authorize_user
        authorize Task
    end

    def task_params
        params.require(:task).permit(:title, :description, :feedback, :feedback, :link, :end_time, :status)
    end

    
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/dashboard_helper.rb
module DashboardHelper
end

app/helpers/index_helper.rb
module IndexHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/dashboard/index.html.erb
<section id="dashboard" class="section has-text-white has-text-centered dashboard">
  <div class="albums">
    <% if @tasks.count > 0 %>
      <h2 class="is-size-5 has-text-white-semibold">Pending tasks</h1>
      <br/>
      <div class="columns is-multiline is-mobile">
        <%= render @tasks %>
      </div>   
    <% end %>
  </div>
</section>

app/views/dashboard/welcome.html.erb
<section class="hero is-fullheight">
  <div class="hero-body has-text-centered">
    <div class="container">
      <h1 class="title has-text-weight-light">
        Vinicius Freire came up with <br />
        <span class="has-text-primary">HubTec Test</span>
      </h1>
      <br />
      <h2 class="subtitle has-text-weight-light white label">
        <br />
        • Tasks Management
        <br />
        and
        <br />
        • Admin
      </h2>
      <br />
      <%= link_to "Login", new_user_session_path, class: "button is-medium is-outlined is-primary" %>
      <div class="label">or</div>
      <%= link_to "Sign Up", new_user_registration_path, class: "button is-medium is-outlined is-primary" %>
    </div>
  </div>
</section>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>HubTecTest</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    <meta name="theme-color" content="#000000" />
  </head>

  <body>
    <%= render "shared/menu" %>
    <%= yield %>
  </body>
</html>

app/views/shared/_menu.html.erb
<% if user_signed_in? %>
  <span class="label icon" style="font-size:22px;cursor:pointer" onclick="openNav()">&#9776;</span>
  <aside id="mySidenav" class="sidenav menu">
    <div class="card">
      <div class="card-content center">
        <div class="media">
          <div class="media-left">
            <figure class="image is-96x96">
                <%= image_tag @current_user.avatar rescue nil %>
            </figure>
          </div>
          <div class="media-content">
            <p class="title is-6"><%= current_user.nickname %></p>
          </div>
        </div>
      </div>
    </div>
    <div class="container">
      <ul class="menu-list">
          <li><a href ="/" class="text" onclick="closeNav()"><img class="icon is-small is-left i" src="/images/menu/home.svg">
            Dashboard</a></li>
      </ul>
      <% if current_user and current_user.admin?  %>
        <ul class="menu-list">
          <li><a href ="/admin" class="text" onclick="closeNav()"><img class="icon is-small is-left" src="/images/menu/admin.svg">
            Administrativo</a></li>
        </ul>
      <% end %>
      <p class="menu-label">
          Personal
      </p>
      <% if current_user %>
      <ul class="menu-list">
        <li><a href ="/tasks" class="text" onclick="closeNav()"><img class="icon is-small is-left" src="/images/menu/tasks.svg"></i>
              Tasks</a></li>
      </ul>
      <ul class="menu-list">
        <li><a data-method="delete" href="/users/sign_out" class="text"><img class="icon is-small is-left" src="/images/menu/logout.svg"></i>
            Logout</a></li>
      </ul>
      <% end %>
    </div>
    <a href="javascript:void(0)" class="closebtn" onclick="closeNav()">&times;</a>
  </aside>
<% end %>

app/views/tasks/_form.html.erb
<%= form_for(@task) do |f| %>
    
    <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
    <% if @task.errors.any? %>
        <div id="error_explanation">
            <h2><%= pluralize(@task.errors.count, "error") %> prohibited this task from being saved:</h2>

            <ul>
            <% @task.errors.full_messages.each do |msg| %>
                <li><%= msg %></li>
            <% end %>
            </ul>
        </div>
    <% end %>

    <section class="modal-card-body">

        <div class="field">
            <%= text_field(:task, :title,:class => "input", :placeholder => "title") %>
        </div>
        <div class="field">
            <%= text_field(:task, :description, :class => "input", :placeholder => "description") %>
        </div>

        <div class="field">
            <%= text_field(:task, :link, :class => "input",:placeholder => "link") %>
        </div>

        <% if @task.id %>
            <div class="field">
                <%= text_field(:task, :feedback, :class => "input",:placeholder => "feedback") %>
            </div>

            <div class="field">
                <%=select(:task, :status, %w[development test])%>
            </div>
        <% end %>
        
        <div class="field">
            <%= datetime_local_field(:task, :end_time, :class => "input") %>
        </div>

    </section>

    <footer class="modal-card-foot">
        <% if @task.id %>
            <button type='submit' class="button is-success">update</button>
        <% else %>
            <button type='submit' class="button is-success">create</button>
            <a class="button" id="closeModal">Close</a>
        <% end %>
    </footer>
<% end %>

app/views/tasks/_new.html.erb
<div class="modal">
  <div class="modal-background" onclick="closeModal()"></div>
  <div class="modal-card">
    <header class="modal-card-head">
      <p class="modal-card-title">New Task</p>
    </header>
    <%= render 'tasks/form', task: @task %>
  </div>
</div>

app/views/tasks/_task.html.erb
<div class="column col-ajust is-full-mobile is-one-third-desktop">
  <%= link_to task do %>
    <div class="movie_card" id="bright">
        <div class="info_section">
            <div class="movie_header">
                <p class="is-size-6 is-size-7-mobile has-text-grey-dark"><%= task.title %></p>
                <p class="is-size-7 is-size-7-mobile has-text-grey"><%= task.description %></p>
            </div>
        </div>
        <div class="blur_back bright_back">
            <i class="fa fa-clock-o" style="font-size:22px;"></i>
            <p class="has-text-black-ter" style="font-size:14px">
                <%= task.status %>
            </p>
        </div>
    </div>
  <% end %>
</div>

app/views/tasks/edit.html.erb
<section>
  <%= render 'tasks/form', task: @task %>
</section>

app/views/tasks/index.html.erb
<section id="dashboard" class="section has-text-white has-text-centered dashboard">
  <%= render 'tasks/new'%>
  <div class="albums">
    <div class="columns is-multiline is-mobile">
        <%= render @tasks %>
    </div>
  </div>
  <div class="floating">
    <a class="button is-primary circular" id="showModal">+</a>
  </div>
</section>

app/views/tasks/show.html.erb
<section id="dashboard" class="section dashboard">
  <% if flash[:notice] %>
    <div class="subtitle has-text-weight-light white label"><%= flash[:notice] %></div>
  <% end %>
  <header class="modal-card-head">
    <p class="modal-card-title"><%= @task.title %></p>
  </header>
  <section class="modal-card-body">
  <table>
      <tr>
        <th class="text">Title: </th>
        <td><%=@task.title%></td> 
      </tr>
      <tr>
        <th class="text">Descrição: </th>
        <td><%=@task.description%></td> 
      </tr>
      <tr>
        <th class="text">Status: </th>
        <td><%=@task.status%></td> 
      </tr>
      <tr>
        <th class="text">Link: </th>
        <td><%=@task.link%></td> 
      </tr>
      <tr>
        <th class="text">Feedback: </th>
        <td><%=@task.feedback%></td> 
      </tr>
      <tr>
        <th class="text">Start: </th>
        <td> <%= @task.created_at.strftime("%d/%m/%Y at %I:%M%p")%></td> 
      </tr>
      <tr>
        <th class="text">Deadline: </th>
        <td> <%= @task.end_time.strftime("%d/%m/%Y at %I:%M%p")%></td> 
      </tr>
    </table>
  </section>
  <footer class="modal-card-foot">
    <%= link_to 'Delete', @task, :method => :delete, data: {:confirm => "You sure?" }, class: "button is-danger" %>
    <%= link_to 'Edit', edit_task_path(@task), class: "button is-outlined" %>
  </footer>
</section>